// Duplicated code !!!

// CIDs
const NS_PREFSERVICE_CONTRACTID = "@mozilla.org/preferences-service;1";
const CONSOLE_CONTRACTID = "@mozilla.org/consoleservice;1";

// interfaces
const ifs = Components.interfaces;
const nsIPrefService = ifs.nsIPrefService;
const nsIConsoleService = ifs.nsIConsoleService;

const NUXEO_LIVE_MIME_TYPE = "application/x-nuxeo-liveedit";
const NUXEO_NXWSS_MIME_TYPE = "application/x-nuxeo-wssedit";
const ACCEPT_PREF_BROWSER_KEY = "network.http.accept.default";
const PREF_BRANCH = "extensions.nxedit.";
const NXDEBUG = true;

function debugLog(msg) {
    if (NXDEBUG) {
        dump(msg + "\n");
        Components.classes[CONSOLE_CONTRACTID].getService(nsIConsoleService)
                .logStringMessage(msg + "\n");
    }
}

setOneOfTheMimes = function(isCompat, setNXWss, mimeTypeMap) {
    var PrefService = Components.classes[NS_PREFSERVICE_CONTRACTID]
            .getService(nsIPrefService);
    var prefs = PrefService.getBranch("");
    var currentAccept = prefs.getCharPref(ACCEPT_PREF_BROWSER_KEY);
    var mts = mimeTypeMap.getKeys();
    
    //first remove possible existing mime type
    var idx = currentAccept.indexOf(NUXEO_NXWSS_MIME_TYPE);
    oldAccept = currentAccept;
    if (idx >= 0) {
        //we have the NXWSS mime type present, remove it
        if (idx > 1) {
            //keep the initial part until the token (without comma)
            currentAccept = currentAccept.substring(0, idx - 1);
        } else {
            //NXWSS type is the first
            currentAccept = "";
        }
        var idx2 = oldAccept.indexOf(',', idx);
        if (idx2 < 0) {
            //it is the last one, nothing else to do
        } else {
            //it is something remaining too
            currentAccept = currentAccept + oldAccept.substring(
                    idx2, oldAccept.length);
        }
    }
    idx = currentAccept.indexOf(NUXEO_LIVE_MIME_TYPE);
    oldAccept = currentAccept;
    if (idx >= 0) {
        //we have the LiveEdit mime type present, remove it
        if (idx > 1) {
            //keep the initial part until the token (without comma)
            currentAccept = currentAccept.substring(0, idx - 1);
        } else {
            //NXWSS type is the first
            currentAccept = "";
        }
        var idx2 = oldAccept.indexOf(',', idx);
        if (idx2 < 0) {
            //it is the last one, nothing else to do
        } else {
            //it is something remaining too
            currentAccept = currentAccept + oldAccept.substring(
                    idx2, oldAccept.length);
        }
    }
    
    //need to see which one is requested one
    var mimeType = NUXEO_LIVE_MIME_TYPE;
    if (setNXWss) {
        mimeType = NUXEO_NXWSS_MIME_TYPE;
    }
    //and add it: new header
    currentAccept = currentAccept + "," + mimeType;
    for ( var i = 0; i < mts.length; i++) {
        if (isCompat) {
            currentAccept = currentAccept + ";" + mts[i].replace("/","!");
        } else {
            currentAccept = currentAccept + ";" + "ext" + i + "=\"" + mts[i] + "\"";
        }
    }

    prefs.setCharPref(ACCEPT_PREF_BROWSER_KEY, currentAccept);
}

setUpInitButtons = function(mimeTypeMap) {
    var PrefService = Components.classes[NS_PREFSERVICE_CONTRACTID]
            .getService(nsIPrefService);
    var prefs = PrefService.getBranch("");

    var isNxWss = prefs.getCharPref(PREF_BRANCH + "isnxwss");
    debugLog("IsNxWss : " + isNxWss);
    var check_nxwss = document.getElementById('check_nxwss');
    check_nxwss.checked = "true" == isNxWss ? true : false;

    var isCompat = prefs.getCharPref(PREF_BRANCH + "iscompat");
    debugLog("IsCompat : " + isCompat);
    var check_compat = document.getElementById('check_compat');
    check_compat.checked = "true" == isCompat ? true : false;

    try {
        setupAcceptHeaderIfNeeded(mimeTypeMap);
    } catch (e) {
        debugLog(e);
    }
}

setupAcceptHeaderIfNeeded = function(mimeTypeMap) {
    var mappingStr = "" + document.getElementById("p_nxeditMimeMapping").value;
    var map = getMapFromStr(mappingStr);

    debugLog("standAlone:setupAcceptHeaderIfNeeded");

    var PrefService = Components.classes[NS_PREFSERVICE_CONTRACTID]
            .getService(nsIPrefService);
    var prefs = PrefService.getBranch("");

    var check_nxwss = document.getElementById('check_nxwss');
    prefs.setCharPref(PREF_BRANCH + "isnxwss", check_nxwss.checked + "");
    var check_compat = document.getElementById('check_compat');
    prefs.setCharPref(PREF_BRANCH + "iscompat", check_compat.checked + "");

    debugLog("Compat: " + check_compat.checked);
    debugLog("NxWss: " + check_nxwss.checked);
    setOneOfTheMimes(check_compat.checked, check_nxwss.checked, map);
}
